# coding: utf-8

"""
Code generated by OpenAPI Generator (https://openapi-generator.tech), manual changes will be lost - read more on https://github.com/algolia/api-clients-automation. DO NOT EDIT.
"""

from __future__ import annotations

from json import loads
from sys import version_info
from typing import Any, Dict, Optional

from pydantic import BaseModel, ConfigDict, Field

if version_info >= (3, 11):
    from typing import Self
else:
    from typing_extensions import Self


from algoliasearch.ingestion.models.run_outcome import RunOutcome
from algoliasearch.ingestion.models.run_progress import RunProgress
from algoliasearch.ingestion.models.run_reason_code import RunReasonCode
from algoliasearch.ingestion.models.run_status import RunStatus
from algoliasearch.ingestion.models.run_type import RunType


class Run(BaseModel):
    """
    Run
    """

    run_id: str = Field(alias="runID")
    """ Universally unique identifier (UUID) of a task run. """
    app_id: str = Field(alias="appID")
    task_id: str = Field(alias="taskID")
    """ Universally unique identifier (UUID) of a task. """
    status: RunStatus = Field(alias="status")
    progress: Optional[RunProgress] = Field(default=None, alias="progress")
    outcome: Optional[RunOutcome] = Field(default=None, alias="outcome")
    failure_threshold: Optional[int] = Field(default=None, alias="failureThreshold")
    """ Maximum accepted percentage of failures for a task run to finish successfully. """
    reason: Optional[str] = Field(default=None, alias="reason")
    """ More information about the task run's outcome. """
    reason_code: Optional[RunReasonCode] = Field(default=None, alias="reasonCode")
    type: RunType = Field(alias="type")
    created_at: str = Field(alias="createdAt")
    """ Date of creation in RFC 3339 format. """
    started_at: Optional[str] = Field(default=None, alias="startedAt")
    """ Date of start in RFC 3339 format. """
    finished_at: Optional[str] = Field(default=None, alias="finishedAt")
    """ Date of finish in RFC 3339 format. """

    model_config = ConfigDict(
        use_enum_values=True,
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_json(self) -> str:
        return self.model_dump_json(by_alias=True, exclude_unset=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Run from a JSON string"""
        return cls.from_dict(loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias."""
        return self.model_dump(
            by_alias=True,
            exclude_none=True,
            exclude_unset=True,
        )

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Run from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj["status"] = obj.get("status")
        obj["progress"] = (
            RunProgress.from_dict(obj["progress"])
            if obj.get("progress") is not None
            else None
        )
        obj["outcome"] = obj.get("outcome")
        obj["reasonCode"] = obj.get("reasonCode")
        obj["type"] = obj.get("type")

        return cls.model_validate(obj)
