# coding: utf-8

"""
Code generated by OpenAPI Generator (https://openapi-generator.tech), manual changes will be lost - read more on https://github.com/algolia/api-clients-automation. DO NOT EDIT.
"""

from __future__ import annotations

from json import loads
from sys import version_info
from typing import Any, Dict, List, Optional

from pydantic import BaseModel, ConfigDict, Field

if version_info >= (3, 11):
    from typing import Self
else:
    from typing_extensions import Self


from algoliasearch.ingestion.models.event import Event


class SourceWatchResponse(BaseModel):
    """
    SourceWatchResponse
    """

    run_id: Optional[str] = Field(default=None, alias="runID")
    """ Universally unique identifier (UUID) of a task run. """
    data: Optional[List[object]] = Field(default=None, alias="data")
    """ depending on the source type, the validation returns sampling data of your source (JSON, CSV, BigQuery). """
    events: Optional[List[Event]] = Field(default=None, alias="events")
    """ in case of error, observability events will be added to the response, if any. """
    message: str = Field(alias="message")
    """ a message describing the outcome of a validate run. """

    model_config = ConfigDict(
        use_enum_values=True,
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_json(self) -> str:
        return self.model_dump_json(by_alias=True, exclude_unset=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SourceWatchResponse from a JSON string"""
        return cls.from_dict(loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias."""
        return self.model_dump(
            by_alias=True,
            exclude_none=True,
            exclude_unset=True,
        )

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SourceWatchResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj["events"] = (
            [Event.from_dict(_item) for _item in obj["events"]]
            if obj.get("events") is not None
            else None
        )

        return cls.model_validate(obj)
