# coding: utf-8

"""
Code generated by OpenAPI Generator (https://openapi-generator.tech), manual changes will be lost - read more on https://github.com/algolia/api-clients-automation. DO NOT EDIT.
"""

from __future__ import annotations

from json import loads
from sys import version_info
from typing import Any, Dict, List, Optional

from pydantic import BaseModel, ConfigDict, Field

if version_info >= (3, 11):
    from typing import Self
else:
    from typing_extensions import Self


class FetchedIndex(BaseModel):
    """
    FetchedIndex
    """

    name: str = Field(alias="name")
    """ Index name. """
    created_at: str = Field(alias="createdAt")
    """ Index creation date. An empty string means that the index has no records. """
    updated_at: str = Field(alias="updatedAt")
    """ Date and time when the object was updated, in RFC 3339 format. """
    entries: int = Field(alias="entries")
    """ Number of records contained in the index. """
    data_size: int = Field(alias="dataSize")
    """ Number of bytes of the index in minified format. """
    file_size: int = Field(alias="fileSize")
    """ Number of bytes of the index binary file. """
    last_build_time_s: int = Field(alias="lastBuildTimeS")
    """ Last build time. """
    number_of_pending_tasks: int = Field(alias="numberOfPendingTasks")
    """ Number of pending indexing operations. This value is deprecated and should not be used. """
    pending_task: bool = Field(alias="pendingTask")
    """ A boolean which says whether the index has pending tasks. This value is deprecated and should not be used. """
    primary: Optional[str] = Field(default=None, alias="primary")
    """ Only present if the index is a replica. Contains the name of the related primary index. """
    replicas: Optional[List[str]] = Field(default=None, alias="replicas")
    """ Only present if the index is a primary index with replicas. Contains the names of all linked replicas. """
    virtual: Optional[bool] = Field(default=None, alias="virtual")
    """ Only present if the index is a [virtual replica](https://www.algolia.com/doc/guides/managing-results/refine-results/sorting/how-to/sort-an-index-alphabetically/#virtual-replicas). """

    model_config = ConfigDict(
        use_enum_values=True,
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_json(self) -> str:
        return self.model_dump_json(by_alias=True, exclude_unset=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FetchedIndex from a JSON string"""
        return cls.from_dict(loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias."""
        return self.model_dump(
            by_alias=True,
            exclude_none=True,
            exclude_unset=True,
        )

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FetchedIndex from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return cls.model_validate(obj)
