# coding: utf-8

"""
Code generated by OpenAPI Generator (https://openapi-generator.tech), manual changes will be lost - read more on https://github.com/algolia/api-clients-automation. DO NOT EDIT.
"""

from __future__ import annotations

from json import loads
from sys import version_info
from typing import Any, Dict, Optional

from pydantic import BaseModel, ConfigDict, Field

if version_info >= (3, 11):
    from typing import Self
else:
    from typing_extensions import Self


from algoliasearch.search.models.anchoring import Anchoring


class SearchRulesParams(BaseModel):
    """
    Rules search parameters.
    """

    query: Optional[str] = Field(default=None, alias="query")
    """ Search query for rules. """
    anchoring: Optional[Anchoring] = Field(default=None, alias="anchoring")
    context: Optional[str] = Field(default=None, alias="context")
    """ Only return rules that match the context (exact match). """
    page: Optional[int] = Field(default=None, alias="page")
    """ Requested page of the API response. """
    hits_per_page: Optional[int] = Field(default=None, alias="hitsPerPage")
    """ Maximum number of hits per page. """
    enabled: Optional[bool] = Field(default=None, alias="enabled")
    """ If `true`, return only enabled rules. If `false`, return only inactive rules. By default, _all_ rules are returned.  """

    model_config = ConfigDict(
        use_enum_values=True,
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_json(self) -> str:
        return self.model_dump_json(by_alias=True, exclude_unset=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SearchRulesParams from a JSON string"""
        return cls.from_dict(loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias."""
        return self.model_dump(
            by_alias=True,
            exclude_none=True,
            exclude_unset=True,
        )

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SearchRulesParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj["anchoring"] = obj.get("anchoring")

        return cls.model_validate(obj)
