# coding: utf-8

"""
Code generated by OpenAPI Generator (https://openapi-generator.tech), manual changes will be lost - read more on https://github.com/algolia/api-clients-automation. DO NOT EDIT.
"""

from __future__ import annotations

from json import loads
from re import match
from sys import version_info
from typing import Any, Dict, Optional

from pydantic import BaseModel, ConfigDict, Field, field_validator

if version_info >= (3, 11):
    from typing import Self
else:
    from typing_extensions import Self


from algoliasearch.search.models.user_highlight_result import UserHighlightResult


class UserHit(BaseModel):
    """
    UserHit
    """

    user_id: str = Field(alias="userID")
    """ Unique identifier of the user who makes the search request. """
    cluster_name: str = Field(alias="clusterName")
    """ Cluster name. """
    nb_records: int = Field(alias="nbRecords")
    """ Number of records in the cluster. """
    data_size: int = Field(alias="dataSize")
    """ Data size taken by all the users assigned to the cluster. """
    object_id: str = Field(alias="objectID")
    """ userID of the requested user. Same as userID. """
    highlight_result: UserHighlightResult = Field(alias="_highlightResult")

    @field_validator("user_id")
    def user_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not match(r"^[a-zA-Z0-9 \-*.]+$", value):
            raise ValueError(
                r"must validate the regular expression /^[a-zA-Z0-9 \-*.]+$/"
            )
        return value

    model_config = ConfigDict(
        use_enum_values=True,
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_json(self) -> str:
        return self.model_dump_json(by_alias=True, exclude_unset=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserHit from a JSON string"""
        return cls.from_dict(loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias."""
        return self.model_dump(
            by_alias=True,
            exclude_none=True,
            exclude_unset=True,
        )

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserHit from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj["_highlightResult"] = (
            UserHighlightResult.from_dict(obj["_highlightResult"])
            if obj.get("_highlightResult") is not None
            else None
        )

        return cls.model_validate(obj)
